/*
 *  DialogFOpen.h
 *  Version 2.0.2 / 011212
 *  by Satoshi Takahashi
 */

#ifndef DIALOGFOPEN_H /*pragma once*/
#define DIALOGFOPEN_H

#ifndef SCLLocal
#include <s_Config.h>
#else
#include "s_Config.h"
#endif

#include <stdio.h> /* necessary for FILE */

#if XDialog
#if SunOS
#include <dirent.h>
#else
#include <sys/dir.h>
#endif
#include <s_Toolbox.h>
#endif /*XDialog*/


#ifndef SCLLocal
#include <VarHeader.h>
#include <DialogFOpen-v.c>
#else
#include "VarHeader.h"
#include "DialogFOpen-v.c"
#endif

#if !S_UNIX && !S_CARBON
char* s_GetFullPath(long DirID, int vRefNum);
#endif /*!S_UNIX && !S_CARBON*/

FILE *DialogFOpen(const char* filename, const char* mode);

#if !S_UNIX
OSErr SCLGetFile(OSType fileType, FSSpec *fssP, Boolean *goodP);
//OSErr SCLGetFile(OSType fileType, FSRef *fsrP, Boolean *goodP);
OSErr SCLPutFile(const char *filename, OSType fileType,
    FSSpec *fssP, Boolean *goodP);
//OSErr SCLPutFile(const char *filename, OSType fileType,
    //FSRef *fsrP, Boolean *goodP);

FSSpec DialogFSSpec(void);
#endif

#if S_UNIX
#if XDialog
FILE *XFOpen(char const *filename, char const *mode);
int SXCountFilesInDir(DIR *dir);
void SXSetDialogFileList(DialogPtr dialog, DITLItem *dItem,
			 DIR *dir, int fStart, int getFlag);
int SXIsDir(int selectID, DITLItem *dItem);
#else /*Xdialog*/
FILE *UnixFOpen(char const *fileName, char const *mod);
void UnixCommand();
#endif /*else XDialog*/
#endif /*S_UNIX*/
#if S_CARBON
void SetDefaultFileLocation(FSSpec *fssP);
#endif /*S_CARBON*/

#endif /*pragma once*/
