/*
 *  DrawPictFile.c
 *  Version 1.7.1 / 980206
 *  by Satoshi Takahashi
 */
 
#ifndef DRAW_PICT_FILE_C /*pragma once*/
#define DRAW_PICT_FILE_C
#include <s_Config.h>

#if !S_CARBON
#include <QDOffScreen.h>
#endif

#include <stdio.h>
#include <string.h>

#include <s_Drawing.h>
#include <StartSCL.h>
#include <s_Common.h>
#include <s_RedrawFunc.h>
#include <s_undef.c>

#include <DrawPictFile.h>

GWorldPtr s_gw;
FSSpec s_DPFSS;

void DrawPictFile(void)
{
PicHandle s_pict = 0;
short	pictFileRef;
long	pictSize;
//StandardFileReply	reply;

GWorldPtr currPort;
GDHandle currDev;

//SFTypeList pictType = {'PICT','    ','    ','    '};
short numType = 1; /* PICT type */

char permission = fsCurPerm;

Boolean good;
OSErr error;

	s_GetGWorld((GrafPtr*)&currPort,&currDev);
	s_SetGWorld(s_displayWindow,s_display);

	//StandardGetFile( nil, numType, pictType, &reply);
    if (DDCount())
    {
        s_DPFSS = DDFSSpec();
        good = 1;
    }
    else
        error = SCLGetFile(0, &s_DPFSS, &good);

	//if (reply.sfGood)
    if (good)
	{
			//FSpOpenDF(&reply.sfFile, permission, &pictFileRef);
			FSpOpenDF(&s_DPFSS, permission, &pictFileRef);
			GetEOF(pictFileRef, &pictSize);

			pictSize -= 512;
			if (s_pict = (PicHandle)NewHandle(pictSize))
			{
				SetFPos(pictFileRef, fsFromStart, 512L);
				FSRead(pictFileRef, &pictSize, *s_pict);
			}
			FSClose(pictFileRef);
	}

	s_SetGWorld((GrafPtr)currPort,currDev);
	
	if (s_pict)
	{
		s_DrawPicture(s_pict, &(*s_pict)->picFrame);
	}
}


void DrawPictFileOffScreen(void)
{
PicHandle s_pict = 0;
short	pictFileRef;
long	pictSize;

char permission = fsCurPerm;

Boolean good;
OSErr error;
Rect gr;

    if (DDCount())
    {
        s_DPFSS = DDFSSpec();
        good = 1;
    }
    else
        error = SCLGetFile(0, &s_DPFSS, &good);

    if (good)
	{
			FSpOpenDF(&s_DPFSS, permission, &pictFileRef);
			GetEOF(pictFileRef, &pictSize);

			pictSize -= 512;
			if (s_pict = (PicHandle)NewHandle(pictSize))
			{
				SetFPos(pictFileRef, fsFromStart, 512L);
				FSRead(pictFileRef, &pictSize, *s_pict);
			}
			FSClose(pictFileRef);
	}

	if (!s_pict)
        return;

    gr = (*s_pict)->picFrame;
	if (error = NewGWorld(&s_gw, 0, &gr, 0, 0, 0))
        return;

    NoPurgePixels(GetPortPixMap(s_gw));
    LockPixels(GetPortPixMap(s_gw));
    SetGWorld(s_gw,0);

    DrawPicture(s_pict, &gr);
}

#include <s_define.c>

#endif /*pragma once*/
