/*
 *  Newton.h
 *  Version 1.9 / 010208
 *  by Satoshi Takahashi & Maiko Watanabe
 */

#ifndef NEWTON_H /*pragma once*/
#define NEWTON_H

#include <s_Config.h>

#include <VarHeader.h>
#include <Newton-v.c>

#define NEWTON_LOOP 100

int Newton1(double (*fp)(double), double (*dfp)(double), double *rootp);
void SetNewton1Init(double init);
void SetNewtonPrecision(double precision);
void SetNewton1Precision(double precision);

int Newton3(double (*fp)(double,double,double),double (*gp)(double,double,double),
            double (*hp)(double,double,double),double (*dfxp)(double,double,double),
            double (*dfyp)(double,double,double),double (*dfzp)(double,double,double),
            double (*dgxp)(double,double,double),double (*dgyp)(double,double,double),
			double (*dgzp)(double,double,double),double (*dhxp)(double,double,double),
            double (*dhyp)(double,double,double),double (*dhzp)(double,double,double),
			double *xp,double *yp,double *zp);
void SetNewton3Init(double initx,double inity,double initz);
void SetNewton3Precision(double precision);

#endif /*pragma once*/