/*
 *  StartSCL.c
 *  Version 2.0.2 / 020723
 *  by Satoshi Takahashi & Akiya Iwasaki
 */

#ifndef STARTSCL_C /*pragma once*/
#define STARTSCL_C

#ifndef SCLLocal
#include <s_Config.h>
#else
#include "s_Config.h"
#endif
#if S_CARBON
#include <Carbon/Carbon.h>
#endif


#define S_IN_SATOSHI

#ifndef SCL_USE_WINDOW
#define SCL_USE_WINDOW 1
#endif

#ifndef SCLLocal
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>

#include <StartSCL.h>

#include <s_Debug.h>
#if SCL_USE_WINDOW
#include <s_Drawing.h>
#include <s_RedrawFunc.h>
#include <s_Common.h>
#include <s_undef.c>

#if S_UNIX /* as s_UNIX.h is not in parts-main */
#include <s_UNIX.h>
#include <s_Toolbox.h>

/* for KeyPressed() */
#include <sys/types.h>
#if SunOS || (Linux && 0)
#include <stropts.h>
#endif

#if !Linux
#include <sys/conf.h>
#endif

#if FreeBSD || Linux
#include <sys/ioctl.h>
#include <sys/file.h>
#endif
#endif /*S_UNIX*/

#if !S_UNIX && !S_CARBON
#include <QDOffScreen.h>
#endif
#endif /*SCL_USE_WINDOW*/

#if !S_UNIX
#include <s_AppleEvent.h>
#endif

#include <s_CarbonMacro.h>
#include <s_Carbon.h>

#include <s_undef.c>


#include <s_QDGlobal.h>
#if !S_CARBON
#include <s_CarbonMacro.h>
#endif

#include <StartSCL.h>
#else/*ndef SCLLocal*/
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>

#include "s_Debug.h"
#include "s_Drawing.h"
#include "s_RedrawFunc.h"
#include "s_Common.h"
#include "s_undef.c"

#include <QDOffScreen.h>

#include "s_AppleEvent.h"

#include "s_CarbonMacro.h"
#include "s_Carbon.h"
#include "s_undef.c"
#include "s_QDGlobal.h"
#if !S_CARBON
#include "s_CarbonMacro.h"
#endif

#include "StartSCL.h"
#endif /*else ndef SCLLocal*/

#if !S_UNIX /******************** !!!! UNIX ********************/

#if SCL_USE_WINDOW
#ifdef THINK_C
#if THINK_C < 6
#define s_TEGetText *TEGetText
#else
#define s_TEGetText TEGetText
#endif
#else
#define s_TEGetText TEGetText
#endif


#if defined(NO_COLOR_DRAWING) || defined(NO_REDRAW)
#define SetGWorld(a,b) SetPort((GrafPtr)a)
#endif

/***** Definition of Variables and Functions *****/

GDHandle 		s_devH;
#endif /*SCL_USE_WINDOW*/
#endif /*!S_UNIX*/ /******************** UNIX ********************/

EventRecord s_event;

s_ssType s_ss =
{
	0,	/* startFlag */
	0,	/* initDrawingFlag */
#if S_CARBON
    0,	/* drawCount */
    0,	/* directDraw */
#endif
};

#if SCL_USE_WINDOW
WindowPtr			s_drawingWindow;
WindowPtr			s_displayWindow;
WindowPtr			s_textWindow;
WindowPtr			s_inputWindow;
#if S_CARBON
Rect				s_textBounds = { 23, 0, 540, 250 };
Rect				s_inputBounds = { 40, 0, 55, 350 };
#else
Rect				s_textBounds = { 20, 1, 341, 189 };
Rect				s_inputBounds = { 20, 1, 35, 189 };
#endif
int					s_i_set=0;
int					s_d_set=0; /* drawing bounds is set */
int					s_t_set=0; /* text bounds is set */
int					s_i_save=0;
int					s_d_save=0; /* drawing bounds is saved in resource */
int					s_t_save=0; /* text bounds is saved in resource */

#if !S_UNIX
Str255 s_fontName = "\pMonaco";
#else
Str255 s_fontName = "Monaco";
#endif
short s_fontSize = 12;


#if !S_UNIX /******************** !!!! UNIX ********************/
int					s_windowResFlag=0;
Rect **s_textBoundsH, **s_inputBoundsH, **s_windowBoundsH;
void	(*RedrawWindowP)(void);

#endif /*!S_UNIX*/ /******************** UNIX ********************/

long (*SaveTextP)(char *s);
long (*ReadTextP)(char *s);
void (*PrintTextP)(char* s);
#endif /*SCL_USE_WINDOW*/

#if !S_UNIX /******************** !!!! UNIX ********************/

#if SCL_USE_WINDOW
int s_redrawFlag = 0;


short s_MyResFile; /* Used in Print.c */
#endif /*SCL_USE_WINDOW*/
#endif /*!S_UNIX*/

#if S_CARBON
Pattern s_CarbonQDPat;
#endif
/***** Start *****/

#if SCL_USE_WINDOW
void Start(void)
{
    StartColor();
}

void StartRedraw(void)
{
    s_colorFlag = 1;
    Start1();
    s_RedrawInitDrawing();
}

void StartNoRedraw(void)
{
    s_colorFlag = 1;
    Start1();
    s_NoRedrawInitDrawing();
}

void StartColor(void)
{
    s_colorFlag = 1;
    StartBW();
}

void StartBW(void)
{
    Start1();
    InitDrawing();
}

void StartText(void)
{
    Start();
    ShowText();
}

void StartDrawing(void)
{
    Start();
}

void StartTextOnly(void)
{
#if !S_UNIX
    SetTextBoundsFull();
#endif
    StartBW();
#if !S_UNIX
    HideDrawing();
#endif
}


void StartDrawingOnly(void)
{
    SetDrawingBoundsFull();
    Start();
    HideText();
}


void StartDrawingOnlyColor(void)
{
    StartDrawingOnly();
}


void StartColorDrawingOnly(void)
{
    StartDrawingOnlyColor();
}


#if S_CARBON
void SetDirectDrawOn(void)
{
    s_ss.directDraw = 1;
}


void SetDirectDrawOff(void)
{
    s_ss.directDraw = 0;
}
#endif

#endif /*SCL_USE_Window*/


#if !S_UNIX
void InitToolbox(void)
{
#if !S_CARBON
	MaxApplZone();

	InitGraf(&s_thePort); /* s_thePort is defined in s_QDGlobal.h */
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(0);

	FlushEvents(everyEvent,0);
#endif /*!S_CARBON*/
	InitCursor();
}

#endif /*!S_UNIX*/ /******************** UNIX ********************/

#if SCL_USE_WINDOW
void Start1(void)
{
	if (s_ss.startFlag)
		PrintError("Error: 2nd call of Start()!!");


#if !S_UNIX

	InitToolbox();
	
	s_MyResFile = CurResFile();

	InitAppleEvent();

	if (s_windowResFlag)
		SetWindowBoundsResource();

	SetGoodBounds();

	InitText();

	HandleAppleEvent();


#else /*!S_UNIX*/
	UNIXStart();
#endif /*else !S_UNIX*/

	SaveTextP = &s_longDummyString;
	ReadTextP = &s_longDummyString;
	PrintTextP = &s_voidDummyString;
	
	s_ss.startFlag = 1;

#if DEBUG_SCL
	s_debugFile = fopen("debug-SCL","w");
#endif
}
#endif /*SCL_USE_WINDOW*/

void MinimumStart(void) 	/* use for no window applications like filter */
{
	if (s_ss.startFlag)
		ExitToShell();

#if !S_UNIX
	InitToolbox(); /*most of Toolbox must be initialized to use Dialog*/

	InitAppleEvent();

	HandleAppleEvent();
#endif

	s_ss.startFlag = 1;
}

#if SCL_USE_WINDOW


/***** Setting Bounds Before Start() *****/

void SetDrawingBounds(int l,int t,int r,int b)
{
	SetRect(&s_windowBounds,l,t,r,b);
	s_d_set=1;
	s_d_save=1;
}

#if !S_UNIX /******************** !!!! UNIX ********************/
void SetTextBounds(int l,int t,int r,int b)
{
	SetRect(&s_textBounds,l,t,r,b);
	s_t_set=1;
	s_t_save=1;
}

void SetGoodBounds(void)
{
#if S_CARBON
Rect boundsRect;
#endif

	if(!s_devH) s_devH = GetGDevice();
#if S_CARBON
        GetAvailableWindowPositioningBounds(s_devH, &boundsRect);
	if(!s_d_set)
		SetDrawingBounds(s_windowBounds.left/s_d_scale,
			s_windowBounds.top/s_d_scale,
			(boundsRect.right)/s_d_scale-1,
            (boundsRect.bottom)/s_d_scale-1);
	if(!s_t_set)
		SetTextBounds(s_textBounds.left, s_textBounds.top,
			s_textBounds.right, (boundsRect.bottom)-1);
	if(!s_i_set)
		SetInputBounds(s_inputBounds.left, 40,
                        s_textBounds.right, 55);
#else /*S_CARBON*/
	if(!s_d_set)
		SetDrawingBounds(s_windowBounds.left/s_d_scale,
			s_windowBounds.top/s_d_scale,
			(**s_devH).gdRect.right/s_d_scale-1,(**s_devH).gdRect.bottom/s_d_scale-1);
	if(!s_t_set)
		SetTextBounds(s_textBounds.left,s_textBounds.top,
			s_textBounds.right,(**s_devH).gdRect.bottom-1);
	if(!s_i_set)
		SetInputBounds(s_inputBounds.left,20,
			s_textBounds.right,35);
#endif /*else S_CARBON*/
}

#endif /*!S_UNIX*/ /******************** UNIX ********************/

void SetDrawingBoundsFull(void)
{
#if !S_UNIX
#if S_CARBON
Rect boundsRect;
#endif

	if(!s_devH) s_devH=GetGDevice();
#if S_CARBON
    GetAvailableWindowPositioningBounds(s_devH, &boundsRect);
	SetDrawingBounds(boundsRect.left, boundsRect.top, boundsRect.right,
		boundsRect.bottom);
#else
	SetDrawingBounds(1,s_windowBounds.top,(**s_devH).gdRect.right-1,
		(**s_devH).gdRect.bottom-1);
#endif
	s_d_set=1;
#endif /*!S_UNIX*/
}

void SetTextBoundsFull(void)
{
#if !S_UNIX
#if S_CARBON
Rect boundsRect;
#endif
	if(!s_devH) s_devH=GetGDevice();
#if S_CARBON
    GetAvailableWindowPositioningBounds(s_devH, &boundsRect);
	SetTextBounds(boundsRect.left, boundsRect.top, boundsRect.right,
		boundsRect.bottom);
#else
	SetTextBounds(1,20,(**s_devH).gdRect.right-1,
			(**s_devH).gdRect.bottom-1);
#endif
	s_t_set=1;
#endif /*!S_UNIX*/
}

#if !S_UNIX /******************** !!!! UNIX ********************/

/***** Setting Window Bounds from Resource *****/

void SetWindowBoundsResource(void)
{
	if (s_t_save) 
	{
		if(!(s_textBoundsH = (Rect**)GetResource('SCL1',128)))
		{
			s_textBoundsH = (Rect**)NewHandle((long)sizeof(Rect));
			AddResource((Handle)s_textBoundsH,'SCL1',128,"\pSCL Text Bounds");
		}
		LoadResource((Handle)s_textBoundsH);
		HNoPurge((Handle)s_textBoundsH);
		CopyRect(s_textBounds,**s_textBoundsH);
		ChangedResource((Handle)s_textBoundsH);
		WriteResource((Handle)s_textBoundsH);
		HPurge((Handle)s_textBoundsH);
	}
	else
	{
		s_textBoundsH = (Rect**)GetResource('SCL1',128);
		if (s_textBoundsH)
		{
			CopyRect(**s_textBoundsH,s_textBounds);
			s_t_set=1;
		}
	}
	if (s_i_save) 
	{
		if(!(s_inputBoundsH = (Rect**)GetResource('SCL1',129)))
		{
			s_inputBoundsH = (Rect**)NewHandle((long)sizeof(Rect));
			AddResource((Handle)s_inputBoundsH,'SCL1',129,"\pSCL Input Bounds");
		}
		LoadResource((Handle)s_inputBoundsH);
		HNoPurge((Handle)s_inputBoundsH);
		CopyRect(s_inputBounds,**s_inputBoundsH);
		ChangedResource((Handle)s_inputBoundsH);
		WriteResource((Handle)s_inputBoundsH);
		HPurge((Handle)s_inputBoundsH);
	}
	else
	{
		s_inputBoundsH = (Rect**)GetResource('SCL1',129);
		if (s_inputBoundsH)
		{
			CopyRect(**s_inputBoundsH,s_inputBounds);
			s_i_set=1;
		}
	}
	if (s_d_save) 
	{
		if(!(s_windowBoundsH = (Rect**)GetResource('SCL1',130)))
		{
			s_windowBoundsH = (Rect**)NewHandle((long)sizeof(Rect));
			AddResource((Handle)s_windowBoundsH,'SCL1',130,"\pSCL Drawing Bounds");
		}
		LoadResource((Handle)s_windowBoundsH);
		HNoPurge((Handle)s_windowBoundsH);
		CopyRect(s_windowBounds,**s_windowBoundsH);
		ChangedResource((Handle)s_windowBoundsH);
		WriteResource((Handle)s_windowBoundsH);
		HPurge((Handle)s_windowBoundsH);
	}
	else
	{
		s_windowBoundsH = (Rect**)GetResource('SCL1',130);
		if (s_windowBoundsH)
		{
			CopyRect(**s_windowBoundsH,s_windowBounds);
			s_d_set=1;
		}
	}
}
#endif /*!S_UNIX*/

/***** PSet for X *****/
#if S_UNIX
void PSet(short x, short y)
{
	if (s_UNIX.drawingFlag)
	{
		fprintf(s_UNIX.drawingFile,"PSet(%d, %d);\n", x, y);

		if (s_Config.XFlag)
		{
			XDrawPoint( thePort->display, thePort->win, thePort->gc,
					x, y);
			XFlush( thePort->display );
		}
	}
}
#endif /*S_UNIX*/

#if !S_UNIX

/***** Setting Fonts Before Start() *****/

void SetStartFont(char* s)
{
	s_fontName[0]=strlen(s);
	strcpy((char*)(s_fontName+1),s);
}



/***** Events *****/

extern RgnHandle	mouseRgn;

int s_updateFlag = 1;
void SetUpdateOff(void)
{
	s_updateFlag = 0;
}

#endif /*!S_UNIX*/

/* define Arrow Keys */

#define LEFT_ARROW	0x1c
#define RIGHT_ARROW	0x1d
#define UP_ARROW		0x1e
#define DOWN_ARROW	0x1f

void Stop(void)
{
#if !S_UNIX

int done =0;
int i;
char inputChar;

	FlushEvents(everyEvent,0);
	do
	{
		if(WaitNextEvent(everyEvent, &s_event, S_WNTIME, 0))  /* changed by using 'if' to conform with NeXT version */
		{
			switch(s_event.what)
			{
			case mouseDown:
					done = 1;
				break;
			case autoKey:
			case keyDown:
					inputChar = s_event.message&charCodeMask;
					switch(inputChar)
					{
						case LEFT_ARROW: /* Arrow Keys */
						case RIGHT_ARROW:
						case UP_ARROW:
						case DOWN_ARROW:
								TEActivate(s_textH);
								if(s_event.modifiers&(optionKey+cmdKey))
									for (i = 0; i<20;i++)
										TEKey((long)(inputChar), s_textH);
								TEKey((long)(inputChar), s_textH);
							break;
						default:
								done = 1;
							break;
					}
				break;
			case updateEvt:
#if !S_CARBON
					if ( s_updateFlag) s_Update();
#endif
				break;
			default:
				break;
			}
		}
//		TEIdle(s_textH);
	} while(!done);
	if ( (s_event.where.v < 30) && (s_event.modifiers&(alphaLock|shiftKey)) )
		ExitToShell();
#else /*!S_UNIX*/

	if (s_Config.foreground)
	{
		if (s_Config.XFlag)
		{
			do
			{
				sleep(1);
			} while ((!MousePressed()) && (!KeyPressed()));
		}
		else
			fgets(s_UNIX.ans,256,stdin);
	}
	
#endif /*!S_UNIX*/
}
#endif /*SCL_USE_WINDOW*/


void WaitTick(long tick)
{
	CheckPause();
	tick += TickCount();
	while(TickCount() < tick)
	{
		CheckPause();
	};
}

int KeyPressedCheckPause(void)
{
#if S_UNIX
int count;
#if FreeBSD
int what;
#endif
#endif
#if !S_UNIX
	CheckPause();
	return GetNextEvent(keyDownMask,&s_event);
#else /*!S_UNIX*/
	CheckPause();
#if SunOS
	if (ioctl(0, I_NREAD, &count))
	{
		ioctl(0, I_FLUSH, FLUSHR);
		return 1;
	}
#endif
#if Linux
	ioctl(0, FIONREAD, &count);
	if (count)
	{
		ioctl(0, TCFLSH, TCIFLUSH);
		return 1;
	}
#endif
#if FreeBSD
	ioctl(0, FIONREAD, &count);
	if (count)
	{
		what = FREAD;
		ioctl(0, TIOCFLUSH, &what);
		return 1;
	}
#endif
	if (s_Config.XFlag)
	{
		return GetNextEvent(keyDownMask,&s_event);
	}
	return 0;
#if 0 /* abolish */
	else
	{
		s_UNIX.sec=time(0);
		if (s_UNIX.stopSec > s_UNIX.sec)
			return(0);
		else
		{
	 		s_UNIX.stopSec = s_UNIX.sec + s_UNIX.stopInterval;
			printf("Continue ? (y/n) ");
			fgets(s_UNIX.ans,256,stdin);
			if (s_UNIX.ans[0]=='y')
				return (0);
			else
				return (1);
		}
	}
#endif /*0*/
#endif /*else !S_UNIX*/
}


int MousePressedCheckPause(void)
{
#if !S_UNIX
	CheckPause();
	return GetNextEvent(mDownMask,&s_event);
#else /*!S_UNIX*/
	if (s_Config.XFlag)
	{
		CheckPause();
		return GetNextEvent(mDownMask,&s_event);
	}
	else
		return KeyPressed();
#endif /*else !S_UNIX*/

}


char s_message1[]="\rStopping ...\rClick center and lower part to continue\r\
Shift + click uppermost part of Menu Bar to quit\r", s_message2[]="Now continuing ...\r";

void CheckPause(void)
{
#if !S_UNIX
	FlushEvents(0,0);
#if SCL_USE_WINDOW
	if(WaitNextEvent(updateMask,&s_event, 0, 0))
	{
#if !S_CARBON
		s_Update();
#endif
	}
#endif /*SCL_USE_WINDOW*/
	WaitNextEvent(0, &s_event, 0, 0);
#if SCL_USE_WINDOW
	if ((s_event.where.v < 30) && (s_event.modifiers&(alphaLock|shiftKey)))
	{
		TEInsert(s_message1,strlen(s_message1),s_textH);
		TESelView(s_textH);
		Stop();
		TEInsert(s_message2,strlen(s_message2),s_textH);
		TESelView(s_textH);
	}
#endif /*SCL_USE_WINDOW*/
#endif /*!S_UNIX*/
}

#if SCL_USE_WINDOW

void SetKeyPressedTime(unsigned long t)
{
#if S_UNIX
	s_UNIX.stopInterval = t;
#endif
}

#if !S_UNIX /******************** !!! UNIX ********************/

#if !S_CARBON
void s_Update(void)
{
	BeginUpdate((WindowPtr)s_event.message);
	if ((WindowPtr)s_event.message==s_textWindow)
	{
		TEUpdate(&s_textWindow->portRect,s_textH);
	}
	else if ((WindowPtr)s_event.message==s_inputWindow)
	{
		TEUpdate(&s_inputWindow->portRect,s_inputH);
	}
	else if ((WindowPtr)s_event.message==s_redrawWindow)
	{
		(*RedrawWindowP)();
	}
	EndUpdate((WindowPtr)s_event.message);
}
#endif /*!S_CARBON*/

/***** Text *****/

WindowPtr	s_textWindow, s_inputWindow;
TEHandle	s_textH, s_inputH;
char			s_inputChar;
Rect			s_textRect,	s_inputRect;
#endif /*!S_UNIX*/ /******************** UNIX ********************/

Boolean s_textSaveFlag = 0, s_textPrintFlag = 0, s_textReadFlag = 0;

#if !S_UNIX /******************** !!! UNIX ********************/
int textFileEnd = 0;


void InitText(void)
{
short	s_fontNum=4;

	s_textWindow=NewWindow(nil,&s_textBounds,(unsigned char *)"\pText",
														true,altDBoxProc,(WindowPtr)-1L,true,0);
	//SetPort(s_textWindow);
	s_SetGWorld(GetWindowPort(s_textWindow), s_display);
	GetFNum(s_fontName,&s_fontNum);
	TextFont(s_fontNum);
	TextSize(s_fontSize);
	s_textRect=*SCWindowBounds(s_textWindow);
	InsetRect(&s_textRect, 4, 0);
	s_textH = TENew(&s_textRect, &s_textRect);
	TEAutoView(TRUE,s_textH);
	s_inputWindow=NewWindow(nil, &s_inputBounds,(unsigned char *)"\pInput",false,
														altDBoxProc,(WindowPtr)-1L,true,0);
	SetPort(GetWindowPort(s_inputWindow));

	GetFNum(s_fontName,&s_fontNum);
	TextFont(s_fontNum);
	TextSize(s_fontSize);

	s_inputRect=*SCWindowBounds(s_inputWindow);

	InsetRect(&s_inputRect,4,0);
	s_inputH = TENew(&s_inputRect,&s_inputRect);
	TEAutoView(TRUE,s_inputH);
	TESetText("\r\r",2L,s_textH);
	TESetText("",0L,s_inputH);
	strlen("");
}

#endif /*!S_UNIX*/ /******************** UNIX ********************/

char s_string[1024]="";

int s_textCharNum = 10000;
int s_textCharNumMax = 32000;
int s_textCharNumMin = 500;


void EraseText(void)
{
#if !S_UNIX
    SetPort(GetWindowPort(s_textWindow));

    EraseRect(SCWindowBounds(s_textWindow));

    SetPort(GetWindowPort(s_drawingWindow));
#else /*!S_UNIX*/
    putchar('\f');
#endif
}
void SetTextCharNum(int n)
{
#if !S_UNIX
	s_textCharNum = min(n+s_textCharNumMin,s_textCharNumMax);
#endif
}

int	s_printf(char const *p, ...)
{
va_list ap;
int s_result;

	va_start(ap, p);
	s_result = s_vprintf(p, ap);
	va_end(ap);
	
	return s_result;
}


int s_vprintf(const char *p, va_list ap)
{
int s_result;

#if !S_UNIX
int i;
GWorldPtr currPort;
GDHandle currDev;
#if (defined(__MWERKS__)&&(__MWERKS__ >= 0x1100)&&MODIFYLF) || DEBUG_MODIFYLF
char format[256];
#endif
#endif /*!S_UNIX*/

	if (!s_ss.startFlag)
	{
		Start();
#if !S_UNIX
		PrintError("Error: Start() is not called!");
#else
        fprintf(stderr, "Error: Start() is not called before printf\n");
        abort();
#endif
	}
#if !S_UNIX
	s_GetGWorld((GrafPtr*)&currPort,&currDev);
	s_SetGWorld(GetWindowPort(s_textWindow),s_display);
	ForeColor(blackColor);
	BackColor(whiteColor);
	CheckPause();
#endif /*!S_UNIX*/


#if (defined(__MWERKS__)&&(__MWERKS__ >= 0x1100)&&MODIFYLF) || DEBUG_MODIFYLF
	LFToF(p, format);
	s_result = vsprintf(s_string, format, ap);
#else
	s_result = vsprintf(s_string, p, ap);
#endif


#if !S_UNIX
	for(i=0;i<strlen(s_string);i++)
	{
		if (s_string[i] == '\n') s_string[i] = '\r';
	}
	TEInsert(s_string,strlen(s_string),s_textH);
	if ((*s_textH)->teLength > s_textCharNum)
	{
	int length;
		EraseText();
		length = (*s_textH)->teLength-(s_textCharNum-s_textCharNumMin);
		TESetText(*TEGetText(s_textH)+(s_textCharNum-s_textCharNumMin),
							length,s_textH);
		//TEUpdate(SCWindowBounds(s_textWindow),s_textH);
		TESetSelect(length-1, length, s_textH);
		//TESelView(s_textH);
		TEUpdate(SCWindowBounds(s_textWindow),s_textH);
		//for(i=0; i < 100; i++)
			//WaitTick(0);
    }
	TESelView(s_textH);
#else /*!S_UNIX*/
	fputs(s_string, s_UNIX.printfFile);
#endif /*else !S_UNIX*/

	if (s_textSaveFlag) (*SaveTextP)(s_string);
	if (s_textPrintFlag) (*PrintTextP)(s_string);

#if !S_UNIX
	s_SetGWorld ((GrafPtr)currPort, currDev);
#endif

	return s_result;
}


int	s_fprintf(FILE *fp, char const *p, ...)
{
va_list ap;
int s_result;
#if (!S_UNIX) && (defined(__MWERKS__)&&(__MWERKS__ >= 0x1100)&&MODIFYLF) || DEBUG_MODIFYLF
char format[256];
#endif

	va_start(ap, p);
	if (fp == stdout)
		s_result = s_vprintf(p, ap);
	else
	{
#if (!S_UNIX) && (defined(__MWERKS__)&&(__MWERKS__ >= 0x1100)&&MODIFYLF) || DEBUG_MODIFYLF
		LFToF(p, format);
		s_result = vfprintf(fp, format, ap);
#else
		s_result = vfprintf(fp, p, ap);
#endif
	}
	va_end(ap);
	
	return s_result;
}


#if !S_UNIX /******************** !!! UNIX ********************/

int	s_sprintfModifyLF(char *string, char const *p, ...)
{
va_list ap;
int s_result;
#if (defined(__MWERKS__)&&(__MWERKS__ >= 0x1100) && MODIFYLF) || DEBUG_MODIFYLF
char format[256];
#endif

	va_start(ap,p);

#if (defined(__MWERKS__)&&(__MWERKS__ >= 0x1100) && MODIFYLF) || DEBUG_MODIFYLF
	LFToF(p, format);
	s_result = vsprintf(string,format,ap);
#else
	s_result = vsprintf(string,p,ap);
#endif

	va_end(ap);

	return s_result;
}


void LFToF(char const *inFormat, char *outFormat)
{
	while (*inFormat)
	{
		while (*inFormat != '%') /* read until % */
		{
			if (!*inFormat)
			{
				*outFormat = *inFormat;
				return;
			}	
			*outFormat++ = *inFormat++;
		}
		
		*outFormat++ = *inFormat++; /* copy '%' */

nextInLoop:;

		if (!*inFormat) /* for safety */
		{
			*outFormat = *inFormat;
			return;
		}	

		switch (*inFormat)
		{
		
		case '-':
		case '+':
		case ' ':
		case '#':
		case '0':
		case '*':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case '.':
			*outFormat++ = *inFormat++;
			goto nextInLoop;
		
		case 'l':
			switch (*(inFormat+1))
			{
				case 'e':
				case 'E':
				case 'f':
				case 'g':
				case 'G':
					inFormat++;
			}

		/* continue */
		
		case 'c':
		case 'd':
		case 'i':
		case 'n':
		
		default:			
			*outFormat++ = *inFormat++;
			goto nextOutLoop;
		}

nextOutLoop:;
	}
	*outFormat = *inFormat;
	return;
}
#endif /*!S_UNIX*/ /******************** UNIX ********************/

int echoInputFlag = 1;
#if !S_UNIX
int	s_scanf(const char* p,...)
{
int	flag;
int max_count=1024;
int	count=0;
int i;

	TESetText("",0L,s_inputH);
	TEActivate(s_inputH);
	TEActivate(s_textH);
	do
	{
		if(s_textReadFlag)
		{
			if(!(*ReadTextP)(&s_inputChar))
			{
				s_inputChar='\r';
				textFileEnd=1;
			}
		}
		else
		{
			flag=1;
			while(flag)
			{
				WaitNextEvent(keyDownMask|autoKeyMask|updateMask, &s_event, 10, 0);
				switch (s_event.what)
				{
				case autoKey:
				case keyDown: flag = 0;
					break;
				case updateEvt:
#if !S_CARBON
					s_Update();
#endif
				default:
					TEIdle(s_textH);
					CheckPause();
					//SystemTask();
				}
			}
			s_inputChar = s_event.message&charCodeMask;
		}
		switch(s_inputChar)
		{
		case LEFT_ARROW: /* Arrow Keys */
		case RIGHT_ARROW:
		case UP_ARROW:
		case DOWN_ARROW:
				if(s_event.modifiers&(optionKey+cmdKey))
					for (i = 0; i<20;i++)
						TEKey((long)(s_inputChar), s_textH);
				TEKey((long)(s_inputChar), s_textH);
			break;
		case '\3': s_inputChar = '\r';
		default:
			if (echoInputFlag) TEKey(s_inputChar,s_textH);
			TEKey(s_inputChar,s_inputH);
			break;
		}
	} while(s_inputChar!='\r' && (count++<max_count));
	TESetSelect((*s_textH)->teLength,(*s_textH)->teLength,s_textH);
	TESelView(s_textH);
	TESelView(s_inputH);
	TEKey('\0',s_inputH);
	if (s_textSaveFlag && echoInputFlag) (*SaveTextP)(*(s_TEGetText(s_inputH)));
	if (s_textPrintFlag && echoInputFlag) (*PrintTextP)(*(s_TEGetText(s_inputH)));
	TEKey('\b',s_inputH);
	TEKey('\0',s_inputH);	
	return sscanf(*(s_TEGetText(s_inputH)),p,*(&p+1),*(&p+2),*(&p+3),
							*(&p+4),*(&p+5),*(&p+6),*(&p+7),*(&p+8),*(&p+9),*(&p+10),
							*(&p+11),*(&p+12),*(&p+13),*(&p+14),*(&p+15),
							*(&p+16),*(&p+17),*(&p+18),*(&p+19),*(&p+20));
}
#endif /*!S_UNIX*/

char* s_fgets(char* s,int n,FILE* stream) /*BM*/
{
#if !S_UNIX
static int fgetsContFlag = 0;
static char *startOfInput;

	if(stream!=stdin)
	{
#if DEBUG_SCRIPT
s_printf("input!=stdin\n");
#endif
		return fgets(s,n,stream);
	}
	else
	{
#if DEBUG_SCRIPT
s_printf("input==stdin\n");
#endif
		if (fgetsContFlag)
		{
		}
		else
		{
			s_scanf("dummy");
			startOfInput = *(s_TEGetText(s_inputH));
		}
		strncpy(s,startOfInput,n-1);
		
		s[n-1] = 0;

		if (s[strlen(s)-1] == '\r' )
		{
			s[strlen(s)-1] = '\n';
			fgetsContFlag = 0;
		}
		else
		{
			startOfInput += n-1;
			fgetsContFlag = 1;
		}
		return s;
	}
#else /*!S_UNIX*/
	return fgets(s,n,stream);
#endif /*else !S_UNIX*/
}

int s_getchar(void)
{
#if !S_UNIX
	while (!GetNextEvent(keyDownMask, &s_event));
	return s_event.message&charCodeMask;
#else /*!S_UNIX*/
	return getchar();
#endif /*else !S_UNIX*/
}

int s_fflush(FILE *stream)
{
#if !S_UNIX
	if ((stream == stdin) || (stream == stdout))
		return 0;
	else
#endif /*!S_UNIX*/
		return fflush(stream);
}

int s_puts(const char *str)
{
	s_printf("%s",str);
	return 0;
}

#if !S_UNIX /******************** !!!! UNIX ********************/
void s_debug(char* s)
{
	TEInsert(s,strlen(s),s_textH);
	TEInsert("\r",1,s_textH);
	TESelView(s_textH);
	Stop();
}


#endif /*!S_UNIX*/ /******************** UNIX ********************/


void SetFont(char *fontName)
{
short fNum;
unsigned char pfontName[20];


#if !S_UNIX
	pfontName[0]=strlen(fontName);
	strcpy((char*)(pfontName+1),fontName);
	GetFNum(pfontName,&fNum);
#else /*!S_UNIX*/
	GetFNum(fontName,&fNum);
#endif /*else !S_UNIX*/
	s_TextFont(fNum);
}




/*** Miscellaneus ***/

void ChangeWindowBoundary(void)
{
#if !S_UNIX
EventRecord s_p_event;
short h, dh;
GrafPtr currPort;
GDHandle currDev;

	s_GetGWorld(&currPort, &currDev);

	while(!(CheckPause(),GetNextEvent(mDownMask,&s_p_event)));

	while(!(CheckPause(),GetNextEvent(mUpMask,&s_p_event)))
	{
		if (s_p_event.where.h < TextWindowWidth())
		{
			s_SetGWorld(GetWindowPort(s_textWindow),s_display);
		}
		else
		{
			s_SetGWorld(GetWindowPort(s_displayWindow),s_display);
		}
		if ((s_p_event.where.h >= TextWindowWidth())&&s_redrawFlag)
		{
			s_PenMode(srcXor);
			s_GlobalToLocal(&s_p_event.where);
			h=s_p_event.where.h;
			s_MoveTo(h,0);
			LineTo(h, DrawingHeight());
			WaitTick(1);
			LineTo(h,0);
			WaitTick(1);
			s_PenMode(srcCopy);
		}
		else
		{
			PenMode(srcXor);
			GlobalToLocal(&s_p_event.where);
			h=s_p_event.where.h;
			MoveTo(h,0);
			LineTo(h,DrawingHeight());
			WaitTick(1);
			LineTo(h,0);
			WaitTick(1);
			PenMode(srcCopy);
		}
	}
	dh = s_p_event.where.h - s_textBounds.right;
	SizeWindow(s_textWindow, TextWindowWidth()+dh, TextHeight(), 1);
	MoveWindow(s_displayWindow, s_p_event.where.h, s_windowBounds.top, 1);
	SizeWindow(s_displayWindow, DrawingWidth() - s_p_event.where.h + s_windowBounds.left,
								 DrawingHeight(), 1);
	s_windowBounds.left = s_p_event.where.h;
	s_textBounds.right = s_p_event.where.h;
	if (s_redrawFlag)
	{
		SizeWindow(s_redrawWindow, DrawingWidth(), DrawingHeight(), 1);
#if !S_CARBON
		RedrawWindow();
#endif
	}
	SetGWorld((GWorldPtr)s_drawingWindow,nil);
	if (s_redrawFlag)
	{
		s_MoveTo(0,0);
	}
	else
	{
		MoveTo(0,0);
	}
	s_textH[0]->destRect.right += dh;
	s_textH[0]->viewRect.right += dh;
	
	if (!s_textBoundsH)
	{
		if(!(s_textBoundsH = (Rect**)GetResource('SCL1',128)))
		{
			s_textBoundsH = (Rect**)NewHandle((long)sizeof(Rect));
			AddResource((Handle)s_textBoundsH,'SCL1',128,"\pSCL Text Bounds");
		}
	}
	LoadResource((Handle)s_textBoundsH);
	HNoPurge((Handle)s_textBoundsH);
	CopyRect(s_textBounds,**s_textBoundsH);
	ChangedResource((Handle)s_textBoundsH);
	WriteResource((Handle)s_textBoundsH);
	HPurge((Handle)s_textBoundsH);
	if (!s_windowBoundsH)
	{
		if(!(s_windowBoundsH = (Rect**)GetResource('SCL1',130)))
		{
			s_windowBoundsH = (Rect**)NewHandle((long)sizeof(Rect));
			AddResource((Handle)s_windowBoundsH,'SCL1',130,"\pSCL Window Bounds");
		}
	}
	LoadResource((Handle)s_windowBoundsH);
	HNoPurge((Handle)s_windowBoundsH);
	CopyRect(s_windowBounds,**s_windowBoundsH);
	ChangedResource((Handle)s_windowBoundsH);
	WriteResource((Handle)s_windowBoundsH);
	HPurge((Handle)s_windowBoundsH);

	s_SetGWorld (currPort, currDev);
#endif /*!S_UNIX*/
}

int s_Dprintf(short x, short y, char *f, ...)
{
va_list ap;
int s_result;
Point p;
#if defined(__MWERKS__)&&(__MWERKS__ >= 0x1100)&&MODIFYLF
char format[256];
#endif

	GetPen(&p);
	va_start(ap,f);
#if defined(__MWERKS__)&&(__MWERKS__ >= 0x1100)&&MODIFYLF
	LFToF(f, format);
	s_result = vsprintf(s_string,format,ap);
#else
	s_result = vsprintf(s_string,f,ap);
#endif
	va_end(ap);
	s_MoveTo(x,y);
	DrawText(s_string,0,strlen(s_string));
	s_MoveTo(p.h,p.v);
	return(s_result);
}

void s_srand(unsigned int seed)
{
static int srandFlag = 0;

	if (srandFlag)
	{
		PrintError("Error: second use of srand\n");
	}
	else
	{
		srand(seed);
		srandFlag = 1;
	}
}
#if defined(NO_COLOR_DRAWING) || defined(NO_REDRAW)
#undef SetGWorld(a,b)
#endif

#ifndef SCLLocal
#include <s_define.c>
#else
#include "s_define.c"
#endif
#endif /*SCL_USE_WINDOW*/

#undef S_IN_SATOSHI

#endif /*pragma once*/

