/*
 *  s_Common.h
 *  Version 2.0 / 010910
 *  by Satoshi Takahashi and Yumiko Takahashi
 */

#ifndef S_COMMON_H /*pragma once*/
#define S_COMMON_H

#ifndef SCLLocal
#include <s_Config.h>
#else
#include "s_Config.h"
#endif

#include <stdlib.h>

#if !S_UNIX /******************** !!!! UNIX ********************/
#ifndef SCLLocal
#include <s_QDGlobal.h>
#else
#include "s_QDGlobal.h"
#endif

extern PenState s_penState;
#endif /*!S_UNIX*/ /******************** UNIX ********************/
#if S_UNIX
#include <s_Toolbox.h> /*definition of Pattern*/
#endif

void s_OOMError(void);
void PrintError(char* errorMessage, ...);
int PrintOSType(OSType type);

void AlertMessage(char *text, int level);


long s_longDummyString(char *s);
void s_voidDummyString(char* s);
void s_voidDummyVoid(void);

/***** Text Handling *****/
void DrawStyleChar(char c);
void DrawStyleText(char *label);
void DrawStyleTextIn(char* text, int *curPosP);
void StyleCommand(char *text, int *posP);
void STSubscript(char *text, int *posP, int superScriptF);
#if 1
void STEndSubscript(int superScriptF, short size);
#endif
void CenterString(char* string);
int s_DirectDprintf(char *f, ...);

#define s_DirectDPrintf s_DirectDprintf
#define s_DirectDPrintF s_DirectDprintf
#define s_DDprintf s_DirectDprintf

#define s_NoErr 0

void SetPattern(Pattern pat, int pnumber);

void *CheckCalloc(size_t num, size_t count);

#endif /*pragma once*/
