/*
 *  s_File.h
 *  Version 2.0 / 010910
 *  by Satoshi Takahashi
 */

#ifndef S_FILE_H /*pragma once*/
#define S_FILE_H

#ifndef SCLLocal
#include <s_Config.h>
#else
#include "s_Config.h"
#endif

#ifndef SCLLocal
#include <VarHeader.h>
#include <s_File-v.c>
#else
#include "VarHeader.h"
#include "s_File-v.c"
#endif


void OSType2CString(OSType type, char *typeStr);
void CString2OSType(char *typeStr, OSType *type);
int IsFolder(char *fullPathName);
int SFpIsFolder(FSSpec *fssP);
void SFGetBaseAndDirName(char* pathString,
		char *baseName,char *dirName);
void SFGetBodyAndExtension(char* fileName,
		char *body,char *extension);
OSErr SFFileCopy(char *sourceFile, char *destFile);
OSErr SFFileMove(char *sourceFile, char *destFile);
OSErr SFFileCopyOrMove(char *sourceFile, char *destFile,
	int copyFlag);
unsigned long GetModDate(char *fileFullName);
unsigned long SFpGetModDate(FSSpec *fssP);
void SFUpdate(char *sourceFile, char *destFile);
void SFFileUpdate(FSSpec *sourceFSSP, FSSpec *destFSSP, char *buf);
#if DirUpdate
void SFDirUpdate(FSSpec *sourceFSSP, FSSpec *destFSSP, char *buf);
void SFDirUpdateIn(FSSpec *sourceFSSP, FSSpec *destFSSP, char *buf,
		int dirFlag);
#endif
OSErr SFSetCreator(FSSpec *fileSpec, OSType destType);
OSErr SFSetType(FSSpec *fileSpecP, OSType destType);
OSType SFGetCreator(FSSpec *fileSpecP);
OSType SFGetType(FSSpec *fileSpecP);
void SFFullPath(FSSpec *fssP, char *fullPath, long pathMax);
OSErr SFPath2Spec(char *fullPath, FSSpec *fssP);
OSErr SFCheckExist(char *filePath, FSSpec *fssP);
int SFExist(char *filePath);
void SFRemoveDirectory(char *filePath);
void SFAllFileDo(FSSpec *targetFolderP, OSErr (doFunc)(FSSpec *targetFile));
void SFAllFileRecurse(FSSpec *sourceFSSP);
void SFAllFileRecurseIn(FSSpec *sourceFSSP, int dirFlag);
#endif /*pragma once*/