/*
 *  s_Print.h
 *  Version 2.0 / 010830
 *  by Satoshi Takahashi
 */


#ifndef S_PRINT_H /*pragma once*/
#define S_PRINT_H
#ifndef SCLLocal
#include <s_Config.h>
#else
#include "s_Config.h"
#endif
#if S_CARBON
#include <Carbon/Carbon.h>
#endif


#define S_PRINT

#ifndef SCLLocal
#include <StartSCL.h>

#include <VarHeader.h>
#include <s_Print-v.c>
#else
#include "StartSCL.h"

#include "VarHeader.h"
#include "s_Print-v.c"
#endif

#if !S_UNIX /******************** !!!! UNIX ********************/

#if !S_CARBON
#if defined(THINK_C)&&(THINK_C < 6)
#include <PrintTraps.h>
#else
#include <Printing.h>
#endif
#endif /*S_CARBON*/


/*****  Printing Graphics *****/

enum {
    s_noBlind = 0,
	s_blind = 1,
	s_samePageSetUp = 2
};

//extern	THPrint		s_prBitMapRecHdl;
//extern short s_MyResFile; /* defined in StartSCL.c */

int	PrintPict(PicHandle pict,int mode);
#if S_CARBON
void DoPrintJob(void (*drawProc)(PicHandle), PicHandle pict, int textFlag);
OSErr PageSetUp(int mode, PMPrintSession session, PMPageFormat *format);
void PictProc(PicHandle pict);
#else /*S_CARBON*/
void DoPrintJob(void (*drawProc)(PicHandle), PicHandle pict, int textFlag, THPrint recHandle);
OSErr	PageSetUp(int mode);
#endif /*S_CARBON*/

#endif /*!S_UNIX*/ /******************** UNIX ********************/


void	BeginPrinting(void);

int		EndPrinting(void);

void	EndPrintingBlind(void);
#if !S_UNIX /******************** !!!! UNIX ********************/

void	EndPrintingSamePageSetUp(void);

#define BeginDrawingPrinting() BeginPrinting()

#define EndDrawingPrinting() EndPrinting()

#endif /*!S_UNIX*/ /******************** UNIX ********************/
void BeginBitMapPrinting(void);
#if !S_UNIX /******************** !!!! UNIX ********************/
void BeginBitMapPrintingSamePageSetUp(void);
#endif /*!S_UNIX*/ /******************** UNIX ********************/
void EndBitMapPrinting(void);

#if S_CARBON
void BitMapProc(PicHandle pict);
#endif

/***** Printing Text *****/

/*extern	int	s_textPrintFlag; /*defined in StartSCL.c*/

extern void	(*PrintTextP)(char* s);

void	BeginTextPrinting(void);
#if !S_UNIX
void SetTextPrintTE(void);
void SetTextPrintFontName(char *name);
void SetTextPrintFontSize(short size);
void TextPrintProc(PicHandle pict);
#endif
void	EndTextPrinting(void);
void	PrintText(char* s);


/***** Capitalize *****/

#define beginprinting BeginPrinting
#define endprinting EndPrinting


#endif /*pragma once*/

