/*
 *  s_RedrawFunc.c
 *  Version 2.0 / 010910
 *  by Satoshi Takahashi
 */

#ifndef S_REDRAWFUNC_C /*pragma once*/
#define S_REDRAWFUNC_C

#ifndef SCLLocal
#include <s_Config.h>
#else
#include "s_Config.h"
#endif
#if S_CARBON
#include <Carbon/Carbon.h>
#endif

#ifndef SCLLocal
#include <StartSCL.h>
#include <s_RedrawFunc.h>
#include <s_QDGlobal.h>
#include <s_Common.h>
#include <s_QDGlobal.h>
#include <EPS.h>
#else
#include "StartSCL.h"
#include "s_RedrawFunc.h"
#include "s_QDGlobal.h"
#include "s_Common.h"
#include "s_QDGlobal.h"
#include "EPS.h"
#endif

#if S_UNIX /* as s_Toolbox.h is not in parts-main */
#include <s_Toolbox.h>
#endif

#if !S_CARBON
#ifndef SCLLocal
#include <s_CarbonMacro.h>
#else
#include "s_CarbonMacro.h"
#endif
#endif


#ifndef SCLLocal
#include <s_undef.c>
#else
#include "s_undef.c"
#endif

#if !S_UNIX /******************** !!!! UNIX ********************/


/* Custom QDProc Functions */

pascal void	s_CustomText(short n,Ptr text,Point num,Point denom)
{
#if !S_CARBON
	s_SetGWorld(s_drawingWindow,nil);
	StdText(n,text,num,denom);
	s_SetGWorld(s_redrawWindow,s_display);
	StdText(n,text,num,denom);
#else /*!S_CARBON*/
long tick;
Point pen;

    if (s_eps.saving)
    {
        GetPortPenLocation(GetQDGlobalsThePort(), &pen);
    }
	StdText(n,text,num,denom);
    tick = TickCount();
    if (s_ss.directDraw || tick > s_ss.drawCount)
    {
        EventAvail(0, &s_event);
        s_ss.drawCount = tick + DRAW_PERIOD;
    }
    if (s_eps.saving)
    {
        fprintf(s_eps.file, "%d %d moveto\n", pen.h, pen.v);
        fprintf(s_eps.file, "1 -1 scale\n");
        fprintf(s_eps.file, "(%*s) show\n", n, text);
        fprintf(s_eps.file, "1 -1 scale\n");
    }
#endif /*else !S_CARBON*/
}


pascal void	s_CustomLine(Point p)
{
#if !S_CARBON
extern int s_drawBackLineFlag;

	s_SetGWorld(s_drawingWindow,nil);
	if (s_drawBackLineFlag)
		StdLine(p);
	s_SetGWorld(s_redrawWindow,s_display);
	
	MapPt(&p,&s_windowBounds, &s_redrawBounds);
	StdLine(p);
#else /*!S_CARBON*/
long tick;
	StdLine(p);
    tick = TickCount();
    if (s_ss.directDraw || tick > s_ss.drawCount)
    {
        EventAvail(0, &s_event);
        s_ss.drawCount = tick + DRAW_PERIOD;
    }
    if (s_eps.saving && (GetPortPenVisibility(GetQDGlobalsThePort()) >= 0))
    {
        fprintf(s_eps.file, "%d %d lineto\n", p.h, p.v);
        fprintf(s_eps.file, "stroke\n");
        fprintf(s_eps.file, "%d %d moveto\n", p.h, p.v);
    }
#endif /*else !S_CARBON*/
}

pascal void	s_CustomRect(GrafVerb verb, Rect *r)
{
#if !S_CARBON
Rect r0;
	SetRect(&r0,r->left,r->top,r->right,r->bottom);
	s_SetGWorld(s_drawingWindow,nil);
	StdRect(verb,&r0);
	s_SetGWorld(s_redrawWindow,s_display);
	
	MapRect(&r0,&s_windowBounds,&s_redrawBounds);
	StdRect(verb,&r0);
#else /*!S_CARBON*/
long tick;
	StdRect(verb,r);
    tick = TickCount();
    if (s_ss.directDraw || tick > s_ss.drawCount)
    {
        EventAvail(0, &s_event);
        s_ss.drawCount = tick + DRAW_PERIOD;
    }
    if (s_eps.saving)
    {
        s_RectPath(r);
        s_DrawPSProc(verb);
    }
#endif /*else !S_CARBON*/
}


pascal void	s_CustomRRect(GrafVerb verb,Rect *r,short w,short h)
{
#if !S_CARBON
Rect r0;
	SetRect(&r0,r->left,r->top,r->right,r->bottom);
	s_SetGWorld(s_drawingWindow,nil);
	StdRRect(verb,&r0,w,h);
	s_SetGWorld(s_redrawWindow,s_display);
	
	MapRect(&r0,&s_windowBounds,&s_redrawBounds);
	StdRRect(verb,&r0,w,h);
#else /*!S_CARBON*/
long tick;
	StdRRect(verb,r,w,h);
    tick = TickCount();
    if (s_ss.directDraw || tick > s_ss.drawCount)
    {
        EventAvail(0, &s_event);
        s_ss.drawCount = tick + DRAW_PERIOD;
    }
    if (s_eps.saving)
    {
        s_RoundRectPath(r, w, h);
        s_DrawPSProc(verb);
    }
#endif /*else !S_CARBON*/
}

pascal void	s_CustomOval(GrafVerb verb,Rect *r)
{
#if !S_CARBON
Rect r0;
	SetRect(&r0,r->left,r->top,r->right,r->bottom);
	s_SetGWorld(s_drawingWindow,nil);
	StdOval(verb,&r0);
	s_SetGWorld(s_redrawWindow,s_display);
	
	MapRect(&r0,&s_windowBounds,&s_redrawBounds);
	StdOval(verb,&r0);
#else /*!S_CARBON*/
long tick;
	StdOval(verb,r);
    tick = TickCount();
    if (s_ss.directDraw || tick > s_ss.drawCount)
    {
        EventAvail(0, &s_event);
        s_ss.drawCount = tick + DRAW_PERIOD;
    }
    if (s_eps.saving)
    {
        s_OvalPath(r);
        s_DrawPSProc(verb);
    }
#endif /*else !S_CARBON*/
}


pascal void	s_CustomArc(GrafVerb verb,Rect *r,short s,short a)
{
#if !S_CARBON
Rect r0;
	SetRect(&r0,r->left,r->top,r->right,r->bottom);
	s_SetGWorld(s_drawingWindow,nil);
	StdArc(verb,&r0,s,a);
	s_SetGWorld(s_redrawWindow,s_display);
	
	MapRect(&r0,&s_windowBounds,&s_redrawBounds);
	StdArc(verb,&r0,s,a);
#else /*!S_CARBON*/
long tick;
	StdArc(verb,r,s,a);
    tick = TickCount();
    if (s_ss.directDraw || tick > s_ss.drawCount)
    {
        EventAvail(0, &s_event);
        s_ss.drawCount = tick + DRAW_PERIOD;
    }
    if (s_eps.saving)
    {
        fprintf(s_eps.file, "gsave\n");
        s_ArcPath(r, s, a, verb);
        s_DrawPSProc(verb);
        fprintf(s_eps.file, "grestore\n");
    }
#endif /*else !S_CARBON*/
}


pascal void	s_CustomPoly(GrafVerb verb,PolyHandle h)
{
#if !S_CARBON
	s_SetGWorld(s_drawingWindow,nil);
	StdPoly(verb,h);
	s_SetGWorld(s_redrawWindow,s_display);
	
	MapPoly(h,&s_windowBounds,&s_redrawBounds);
	StdPoly(verb,h);
	MapPoly(h,&s_redrawBounds,&s_windowBounds);
#else /*!S_CARBON*/
long tick;
	StdPoly(verb,h);
    tick = TickCount();
    if (s_ss.directDraw || tick > s_ss.drawCount)
    {
        EventAvail(0, &s_event);
        s_ss.drawCount = tick + DRAW_PERIOD;
    }
    if (s_eps.saving)
    {
        s_PolyPath(h);
        s_DrawPSProc(verb);
    }
#endif /*else !S_CARBON*/
}


pascal void	s_CustomRgn(GrafVerb verb,RgnHandle h)
{
#if !S_CARBON
	s_SetGWorld(s_drawingWindow,nil);
	StdRgn(verb,h);
	s_SetGWorld(s_redrawWindow,s_display);
	
	MapRgn(h,&s_windowBounds,&s_redrawBounds);
	StdRgn(verb,h);
	MapRgn(h,&s_redrawBounds,&s_windowBounds);
#else /*!S_CARBON*/
long tick;
	StdRgn(verb,h);
    tick = TickCount();
    if (s_ss.directDraw || tick > s_ss.drawCount)
    {
        EventAvail(0, &s_event);
        s_ss.drawCount = tick + DRAW_PERIOD;
    }
#endif /*else !S_CARBON*/
}

pascal void	s_CustomBits(BitMap *b,Rect *s,Rect *d,short m,RgnHandle r)
{
#if !S_CARBON
Rect s0,d0;
	SetRect(&s0,s->left,s->top,s->right,s->bottom);
	SetRect(&d0,d->left,d->top,d->right,d->bottom);
	s_SetGWorld(s_drawingWindow,nil);
	StdBits(b,&s0,&d0,m,r);
	s_SetGWorld(s_redrawWindow,s_display);
	
	MapRect(&s0,&s_windowBounds,&s_redrawBounds);
	MapRect(&d0,&s_windowBounds,&s_redrawBounds);
	MapRgn(r,&s_windowBounds,&s_redrawBounds);
	StdBits(b,&s0,&d0,m,r);
	MapRgn(r,&s_redrawBounds,&s_windowBounds);
#else /*!S_CARBON*/
long tick;
	StdBits(b,s,d,m,r);
    tick = TickCount();
    if (s_ss.directDraw || tick > s_ss.drawCount)
    {
        EventAvail(0, &s_event);
        s_ss.drawCount = tick + DRAW_PERIOD;
    }
#endif /*else !S_CARBON*/
}

/*
short s_CustomTxMeas(short byteCount, Ptr textAddr, Point *numer, Point *denom, FontInfo *info)
{
short r;

//	s_SetGWorld(s_drawingWindow,nil);
//	s_SetGWorld(s_redrawWindow,s_display);
	r=StdTxMeas(byteCount,textAddr,numer,denom,info);
	return r;
}
*/

#endif /*!S_UNIX*/ /******************** UNIX ********************/


void s_RectPath(Rect *rp)
{
	fprintf(s_eps.file, "%d %d moveto\n", rp->left, rp->top);
	fprintf(s_eps.file, "%d %d lineto\n", rp->right, rp->top);
	fprintf(s_eps.file, "%d %d lineto\n", rp->right, rp->bottom);
	fprintf(s_eps.file, "%d %d lineto\n", rp->left, rp->bottom);
	fprintf(s_eps.file, "closepath\n");
}


void s_RoundRectPath(Rect* rp, short ovalWidth, short ovalHeight)
{
double centerWeight = 0.55;
double lineUp, lineDown, lineRight, lineLeft;
double horizontalLeft,horizontalRight, verticalUp,verticalDown;
double top, left, bottom, right;

    top = rp->top;
    left = rp->left;
    bottom = rp->bottom;
    right = rp->right;

	ovalWidth = min(ovalWidth, right - left);
	ovalHeight = min(ovalHeight, bottom - top);

	lineUp = top + ovalHeight/2.0;
	lineDown = bottom - ovalHeight/2.0;
	lineRight = right - ovalWidth/2.0;
	lineLeft = left + ovalWidth/2.0;

	horizontalLeft = (1-centerWeight)*left + centerWeight*lineLeft;
	horizontalRight = (1-centerWeight)*right + centerWeight*lineRight;
	verticalUp = (1-centerWeight)*top + centerWeight*lineUp;
	verticalDown = (1-centerWeight)*bottom + centerWeight*lineDown;
	
	fprintf(s_eps.file, "moveto\n", right,lineUp); 
	fprintf(s_eps.file, "%f %f %f %f %f %f curveto\n",
        right, verticalUp, horizontalRight, top, lineRight, top);
	fprintf(s_eps.file, "moveto\n", lineLeft,top); 
	fprintf(s_eps.file, "%f %f %f %f %f %f curveto\n",
        horizontalLeft, top, left, verticalUp, left, lineUp);
	fprintf(s_eps.file, "moveto\n", left,lineDown); 
	fprintf(s_eps.file, "%f %f %f %f %f %f curveto\n",
        left, verticalDown, horizontalLeft, bottom, lineLeft, bottom);
	fprintf(s_eps.file, "moveto\n", lineRight,bottom); 
	fprintf(s_eps.file, "%f %f %f %f %f %f curveto\n",
        horizontalRight, bottom, right, verticalDown, right, lineDown);
	fprintf(s_eps.file, "closepath\n");
}


void s_OvalPath(Rect* rp)
{
double horizontalCenter,horizontalLeft,horizontalRight,
	verticalCenter,verticalUp,verticalDown;
double centerWeight = 0.55;
double top, left, bottom, right;

    top = rp->top;
    left = rp->left;
    bottom = rp->bottom;
    right = rp->right;

	horizontalCenter = (left + right)/2.0;
	horizontalLeft = (1-centerWeight)*left + centerWeight*horizontalCenter;
	horizontalRight = (1-centerWeight)*right + centerWeight*horizontalCenter;
	verticalCenter = (top + bottom)/2.0;
	verticalUp = (1-centerWeight)*top + centerWeight*verticalCenter;
	verticalDown = (1-centerWeight)*bottom + centerWeight*verticalCenter;
	fprintf(s_eps.file, "%f %f moveto\n", right,verticalCenter);
	fprintf(s_eps.file, "%f %f %f %f %f %f curveto\n",
        right, verticalUp, horizontalRight, top, horizontalCenter, top);
	fprintf(s_eps.file, "%f %f %f %f %f %f curveto\n",
        horizontalLeft, top, left, verticalUp, left, verticalCenter);
	fprintf(s_eps.file, "%f %f %f %f %f %f curveto\n",
        left, verticalDown, horizontalLeft, bottom, horizontalCenter, bottom);
	fprintf(s_eps.file, "%f %f %f %f %f %f curveto\n",
        horizontalRight, bottom, right, verticalDown, right, verticalCenter);
	fprintf(s_eps.file, "closepath\n");
}


void s_ArcPath(Rect *rp, short start, short arc, GrafVerb verb)
{
double width, height, ratio;
int horizontal;
double radius, cx, cy;
double a1, a2;

    width = rp->right - rp->left;
    height = rp->bottom - rp->top;
    cx = (rp->right + rp->left)/2.0;
    cy = (rp->bottom + rp->top)/2.0;

    if (width >= height)
    {
        horizontal = 1;
        ratio = width/height;
        cy *= ratio;
        radius = width/2.0;
        fprintf(s_eps.file, "1 %f scale\n", 1/ratio);
    }
    else
    {
        horizontal = 1;
        ratio = height/width;
        cx *= ratio;
        radius = height/2.0;
        fprintf(s_eps.file, "%f 1 scale\n", 1/ratio);
    }

    a1 = 90 - start;
    if (a1 < 0)
        a1 += 360;
    a2 = a1 - arc;
    a2 += 360*((a2 < 0) - (a2 > 360));

    if (verb == kQDGrafVerbFrame)
        fprintf(s_eps.file, "newpath\n");
    else
        fprintf(s_eps.file, "%f %f moveto\n", cx, cy);

    fprintf(s_eps.file, "%f %f %f %f %f", cx, cy, radius, a1, a2);
    if (arc < 0)
        fprintf(s_eps.file, " arc\n");
    else
        fprintf(s_eps.file, " arcn\n");

    if (verb != kQDGrafVerbFrame)
        fprintf(s_eps.file, "closepath\n");
}



void s_PolyPath(PolyHandle h)
{
int i, vnum;
Polygon *p;
Point *pa;

    HLock(h);
    p = *h;
    pa = p->polyPoints;
    vnum = (p->polySize - 10)/4;
    
	fprintf(s_eps.file, "%d %d moveto\n", pa[0].h, pa[0].v);
    for (i = 1; i < vnum; i++)
    {
        fprintf(s_eps.file, "%d %d lineto\n", pa[i].h, pa[i].v);
	}
	fprintf(s_eps.file, "closepath\n");
    HUnlock(h);
}


void s_DrawPSProc(GrafVerb verb)
{
RGBColor color;
    switch(verb)
    {
    case kQDGrafVerbFrame:
        fprintf(s_eps.file, "strokepath\n");
        /*run down*/
    case kQDGrafVerbPaint:
        break;
    case kQDGrafVerbErase:
        GetPortBackColor(GetQDGlobalsThePort(), &color);
        fprintf(s_eps.file, "%f %f %f setrgbcolor\n",
            color.red/65535.0, color.green/65535.0, color.blue/65535.0);
        break;
    case kQDGrafVerbFill:
        s_PSFillPat();
        break;
    }
    fprintf(s_eps.file, "fill\n");
    
    if ((verb == kQDGrafVerbErase) | (verb == kQDGrafVerbFill))
    {
        GetPortForeColor(GetQDGlobalsThePort(), &color); /*each color is not 0-1 */
        fprintf(s_eps.file, "%f %f %f setrgbcolor\n",
            color.red/65535.0, color.green/65535.0, color.blue/65535.0);
    }
}


void s_PSFillPat(void)
{
#if !S_UNIX
RGBColor rgbColor;
PixPatHandle pix;
unsigned char* pat;
int i;

    fprintf(s_eps.file, "gsave\n"); /*reuse current path*/
    GetPortBackColor(GetQDGlobalsThePort(), &rgbColor);
    fprintf(s_eps.file, "%f %f %f setrgbcolor\n",
        rgbColor.red/65535.0, rgbColor.green/65535.0, rgbColor.blue/65535.0);
    fprintf(s_eps.file, "fill\n");
    fprintf(s_eps.file, "grestore\n");

    fprintf(s_eps.file, "/DeviceRGB setcolorspace\n");
    GetPortForeColor(GetQDGlobalsThePort(), &rgbColor);
    fprintf(s_eps.file, "%f %f %f\n",   /*use as color for pattern*/
        rgbColor.red/65535.0, rgbColor.green/65535.0, rgbColor.blue/65535.0);

    /*define pattern*/
    fprintf(s_eps.file, "<<\n");
    fprintf(s_eps.file, "/PaintType 2 /PatternType 1 /TilingType 1\n");
    fprintf(s_eps.file, "/BBox [0 0 8 8] /XStep 8 /YStep 8\n");
    fprintf(s_eps.file, "/PaintProc {\n");
    fprintf(s_eps.file, "pop\n");
    //fprintf(s_eps.file, "8 8 scale\n");

    pix = NewPixPat();
    GetPortFillPixPat(GetQDGlobalsThePort(), pix);
    HLock(pix);
    pat = pix[0]->pat1Data.pat;
    //fprintf(s_eps.file, "8 8 true [8 0 0 8 0 0] {<\n");
    fprintf(s_eps.file, "8 8 true [1 0 0 1 0 0] {<\n");
    for (i = 0; i < 8; i++)
        fprintf(s_eps.file, "%02X ", (unsigned char)pat[i]);
    fprintf(s_eps.file, "\n");
    fprintf(s_eps.file, ">} imagemask\n}");
    fprintf(s_eps.file, ">>\n");
    fprintf(s_eps.file, "matrix makepattern\n");
    fprintf(s_eps.file, "setpattern\n");
    HUnlock(pix);
#endif /*!S_UNIX*/
}

void	s_MoveTo(int x, int y)
{
	if (!s_ss.startFlag)
	{
		Start();
		PrintError("Error: Start() is not called!");
	}

#if !S_UNIX && !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		MoveTo(x,y);
		s_SetGWorld(s_redrawWindow,s_display);
		MoveTo(x*s_d_scale,y*s_d_scale);
	}
	else
#endif /*!S_UNIX && !S_CARBON*/
	{
		MoveTo(x,y);
	}
#if S_CARBON
    if (s_eps.saving)
        fprintf(s_eps.file, "%d %d moveto\n", x, y);
#endif /*S_CARBON*/
}

void	s_Move(int x, int y)
{
#if !S_UNIX && !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		Move(x,y);
		s_SetGWorld(s_redrawWindow,s_display);
		Move(x*s_d_scale,y*s_d_scale);
	}
	else
#endif /*!S_UNI && !S_CARBONX*/
	{
		Move(x,y);
	}
}

#if S_CARBON
void	s_LineTo(int x, int y)
{
long tick;

    LineTo(x,y);
    tick = TickCount();
    if (s_ss.directDraw || tick > s_ss.drawCount)
    {
        EventAvail(0, &s_event);
        s_ss.drawCount = tick + DRAW_PERIOD;
    }
    
    if (s_eps.saving)
        fprintf(s_eps.file, "%d %d lineto\n", x, DrawingHeight() - y);
}

void	s_Line(int x, int y)
{
long tick;

    Line(x,y);
    tick = TickCount();
    if (s_ss.directDraw || tick > s_ss.drawCount)
    {
        EventAvail(0, &s_event);
        s_ss.drawCount = tick + DRAW_PERIOD;
    }
}
#endif /*S_CARBON*/

#if !S_UNIX /******************** !!!! UNIX ********************/

void	s_GlobalToLocal(Point *p)
{
#if !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
//		s_SetGWorld(s_drawingWindow,nil);
		GlobalToLocal(p);
		MapPt(p,&s_windowBounds,&s_redrawBounds);
//		s_SetGWorld(s_redrawWindow,s_display);
	}
	else
#endif /*!S_CARBON*/
	{
		GlobalToLocal(p);
	}
}
#endif /*!S_UNIX*/ /******************** UNIX ********************/

void	s_ForeColor(long color)
{
#if !S_UNIX && !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		ForeColor(color);
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*!s_UNIX && !S_CARBON*/
	ForeColor(color);
#if S_CARBON
    if (s_eps.saving)
    {
    RGBColor rgbColor;
        GetPortForeColor(GetQDGlobalsThePort(), &rgbColor);
        fprintf(s_eps.file, "%f %f %f setrgbcolor\n",
            rgbColor.red/65535.0, rgbColor.green/65535.0, rgbColor.blue/65535.0);
    }
#endif
}


void	s_BackColor(long color)
{
#if !S_UNIX && !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		BackColor(color);
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*!s_UNIX && !S_CARBON*/
	BackColor(color);
}

void	s_HidePen(void)
{
#if !S_UNIX && !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		HidePen();
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*S_UNIX && !S_CARBON*/
	HidePen();
}

void	s_ShowPen(void)
{
#if !S_UNIX && !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		ShowPen();
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*S_UNIX && !S_CARBON*/
	ShowPen();
}

void	s_SetPenState(PenState *pnState)
{
#if !S_UNIX && !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		SetPenState(pnState);
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*S_UNIX && !S_CARBON*/
	SetPenState(pnState);
}


void	s_PenSize(int width,int height)
{
#if !S_UNIX && !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		PenSize(width,height);
		s_SetGWorld(s_redrawWindow,s_display);
		PenSize(width*s_d_scale + 0.99,height*s_d_scale + 0.99);
	}
	else
#endif /*S_UNIX && !S_CARBON*/
	{
		PenSize(width,height);
	}
}

void	s_PenMode(int mode)
{
#if !S_UNIX && !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		PenMode(mode);
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*S_UNIX && !S_CARBON*/
	PenMode(mode);
}


#if !S_UNIX /******************** !!!! UNIX ********************/
void	s_PenPat(Pattern pat)
{
#if !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		PenPat(QDPattern(pat));
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*!S_CARBON*/
		PenPat(QDPattern(pat));
}

void	s_PenNormal(void)
{
#if !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		PenNormal();
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*!S_CARBON*/
	PenNormal();
}

#endif /*!S_UNIX*/ /******************** UNIX ********************/

void s_TextFont(short font)
{
#if !S_UNIX && !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		TextFont(font);
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*S_UNIX && !S_CARBON*/
	TextFont(font);
#if S_CARBON
    if (s_eps.saving)
    {
        s_SetPSText(font, 0, -1);
    }
#endif
}

void s_TextFace(Style face)
{
#if !S_UNIX && !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		TextFace(face);
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*S_UNIX && !S_CARBON*/
	TextFace(face);
#if S_CARBON
    if (s_eps.saving)
    {
        s_SetPSText(0, 0, face);
    }
#endif
}

#if !S_UNIX /******************** !!!! UNIX ********************/
void s_TextMode(int mode)
{
#if !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		TextMode(mode);
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*!S_CARBON*/
	TextMode(mode);
}

#endif /*!S_UNIX*/ /******************** UNIX ********************/

void s_TextSize(short size)
{
#if !S_UNIX && !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		TextSize(size);
		s_SetGWorld(s_redrawWindow,s_display);
		TextSize(size*s_d_scale);
	}
	else
#endif /*S_UNIX && !S_CARBON*/
	{
		TextSize(size);
	}
#if S_CARBON
    if (s_eps.saving)
    {
    	s_SetPSText(0, size, -1);
    }
#endif
}


void s_SetPSText(short font, short size, Style face)
{
Str255 fontNameP;
char fontName[300];
    if (!font)
        font = GetPortTextFont(GetQDGlobalsThePort());
    if (!size)
        size = GetPortTextSize(GetQDGlobalsThePort());
    if (face == (Style)-1)
        face = GetPortTextFace(GetQDGlobalsThePort());
    FMGetFontFamilyName(font, fontNameP);
    P2CString(fontNameP, fontName);
    s_SetPSFontFace(fontName, face);
    fprintf(s_eps.file, "/%s findfont\n", fontName);
    fprintf(s_eps.file, "%d scalefont\n", size);
    fprintf(s_eps.file, "setfont\n");
}


void s_SetPSFontFace(char *fontName, Style face)
{
    if (strcmp(fontName, "Times") == 0)
    {
        switch(face)
        {
		case 0:
			strcat(fontName, "-Roman");
			break;
		case italic:
			strcat(fontName, "-Italic");
			break;
		case bold:
			strcat(fontName, "-Bold");
			break;
		case bold+italic:
			strcat(fontName, "-BoldItalic");
			break;
		default:
			strcat(fontName, "-Roman");
			break;
		}
    }
    else if ((strcmp(fontName, "Helvetica") == 0)
            ||(strcmp(fontName, "Courier") == 0))
    {
        switch(face)
        {
		case 0:
			strcat(fontName, "");
			break;
		case italic:
			strcat(fontName, "-Oblique");
			break;
		case bold:
			strcat(fontName, "-Bold");
			break;
		case bold+italic:
			strcat(fontName, "-BoldOblique");
			break;
		default:
			strcat(fontName, "");
			break;
		}
    }
    
}

#if !S_UNIX /******************** !!!! UNIX ********************/
void s_SpaceExtra(Fixed extra)
{
#if !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		SpaceExtra(extra);
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*!S_CARBON*/
	SpaceExtra(extra);
}

void	s_FillArc(Rect* rp, short s1, short s2, Pattern pp)
{
#if !S_CARBON
PenState ps;

	if(QDGlobal(thePort)==s_redrawWindow)
	{
		GetPenState(&ps);
		s_PenPat(pp);
		PaintArc(rp, s1, s2);
		s_PenPat(QDPenPattern(ps.pnPat));
	}
	else
#endif /*!S_CARBON*/
	{
		FillArc(rp,s1,s2,QDPattern(pp));
	}
}

#endif /*!S_UNIX*/ /******************** UNIX ********************/
void	s_FillOval(Rect* rp, Pattern pp)
{
#if !S_UNIX && !S_CARBON
PenState ps;

	if(QDGlobal(thePort)==s_redrawWindow)
	{
		GetPenState(&ps);
		s_PenPat(pp);
		PaintOval(rp);
		s_PenPat(QDPenPattern(ps.pnPat));
	}
	else
#endif /*!s_UNIX && !S_CARBON*/
	{
		FillOval(rp, QDPattern(pp));
	}
}

void	s_FillPoly(PolyHandle ph,Pattern pp)
{
#if !S_UNIX && !S_CARBON
PenState ps;

	if(QDGlobal(thePort)==s_redrawWindow)
	{
		GetPenState(&ps);
		s_PenPat(pp);
		PaintPoly(ph);
		s_PenPat(QDPenPattern(ps.pnPat));
	}
	else
#endif /*!s_UNIX && !S_CARBON*/
	{
		FillPoly(ph,QDPattern(pp));
	}
}

void	s_FillRect(Rect* rp,Pattern pp)
{
#if !S_UNIX && !S_CARBON
PenState ps;

	if(QDGlobal(thePort)==s_redrawWindow)
	{
		GetPenState(&ps);
		s_PenPat(pp);
		PaintRect(rp);
		s_PenPat(QDPenPattern(ps.pnPat));
	}
	else
#endif /*!s_UNIX && !S_CARBON*/
	{
		FillRect(rp,QDPattern(pp));
	}
}

#if !S_UNIX /******************** !!!! UNIX ********************/
void	s_FillRgn(RgnHandle rgp,Pattern pp)
{
#if !S_CARBON
PenState ps;

	if(QDGlobal(thePort)==s_redrawWindow)
	{
		GetPenState(&ps);
		s_PenPat(pp);
		PaintRgn(rgp);
		s_PenPat(QDPenPattern(ps.pnPat));
	}
	else
#endif /*!S_CARBON*/
	{
		FillRgn(rgp,QDPattern(pp));
	}
}

void	s_FillRoundRect(Rect* rp,short s1,short s2,Pattern pp)
{
#if !S_CARBON
PenState ps;

	if(QDGlobal(thePort)==s_redrawWindow)
	{
		GetPenState(&ps);
		s_PenPat(pp);
		PaintRoundRect(rp, s1, s2);
		s_PenPat(QDPenPattern(ps.pnPat));
	}
	else
#endif /*!S_CARBON*/
	{
		FillRoundRect(rp,s1,s2,QDPattern(pp));
	}
}

void s_BackPat(Pattern pp)
{
#if !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		BackPat(QDPattern(pp));
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*!S_CARBON*/
		BackPat(QDPattern(pp));
}

#endif /*!S_UNIX*/ /******************** UNIX ********************/

void s_RGBForeColor(RGBColor *color)
{
#if !S_UNIX && !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		RGBForeColor(color);
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*!s_UNIX && !S_CARBON*/
	RGBForeColor(color);		
#if S_CARBON
    if (s_eps.saving)
    {
        fprintf(s_eps.file, "%f %f %f setrgbcolor\n",
            color->red/65535.0, color->green/65535.0, color->blue/65535.0);
    }
#endif
}

void s_RGBBackColor(RGBColor *color)
{
#if !S_UNIX && !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		RGBBackColor(color);
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*!s_UNIX && !S_CARBON*/
	RGBBackColor(color);		
}

#if !S_UNIX /******************** !!!! UNIX ********************/
int s_drawBackLineFlag = 1;

pascal void	s_SetCPixel(short x, short y,RGBColor *c)
{
#if !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_drawBackLineFlag = 0;
		s_SetGWorld(s_drawingWindow,nil);
		SetCPixel(x,y,c);
		s_SetGWorld(s_redrawWindow,s_display);
		SetCPixel(x*s_d_scale,y*s_d_scale,c);
		s_drawBackLineFlag = 1;
	}
	else
#endif /*!S_CARBON*/
	{
		SetCPixel(x,y,c);
	}
}

void	s_PenPixPat(PixPatHandle ppat)
{
#if !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		PenPixPat(ppat);
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*!S_CARBON*/
		PenPixPat(ppat);
}

#ifdef THINK_C
#define GetPenPixPat() \
(((CGrafPtr)thePort)->pnPixPat)
#endif
#ifdef SYMANTEC_C
#define GetPenPixPat() \
(((CGrafPtr)(qd.thePort))->pnPixPat)
#endif
#ifdef __MWERKS__
#define GetPenPixPat() \
(((CGrafPtr)(qd.thePort))->pnPixPat)
#endif

void	s_FillCArc(Rect* rp,short s1,short s2,PixPatHandle pp)
{
#if !S_CARBON
PixPatHandle ps;

	if(QDGlobal(thePort)==s_redrawWindow)
	{
		ps = GetPenPixPat();
		s_PenPixPat(pp);
		PaintArc(rp, s1, s2);
		s_PenPixPat(ps);
	}
	else
#endif /*!S_CARBON*/
	{
		FillCArc(rp,s1,s2,pp);
	}
}

void	s_FillCOval(Rect* rp,PixPatHandle pp)
{
#if !S_CARBON
PixPatHandle ps;

	if(QDGlobal(thePort)==s_redrawWindow)
	{
		ps = GetPenPixPat();
		s_PenPixPat(pp);
		PaintOval(rp);
		s_PenPixPat(ps);
	}
	else
#endif /*!S_CARBON*/
	{
		FillCOval(rp,pp);
	}
}

void	s_FillCPoly(PolyHandle ph,PixPatHandle pp)
{
#if !S_CARBON
PixPatHandle ps;

	if(QDGlobal(thePort)==s_redrawWindow)
	{
		ps = GetPenPixPat();
		s_PenPixPat(pp);
		PaintPoly(ph);
		s_PenPixPat(ps);
	}
	else
#endif /*!S_CARBON*/
	{
		FillCPoly(ph,pp);
	}
}

void	s_FillCRect(Rect* rp,PixPatHandle pp)
{
#if !S_CARBON
PixPatHandle ps;

	if(QDGlobal(thePort)==s_redrawWindow)
	{
		ps = GetPenPixPat();
		s_PenPixPat(pp);
		PaintRect(rp);
		s_PenPixPat(ps);
	}
	else
#endif /*!S_CARBON*/
	{
		FillCRect(rp,pp);
	}
}

void	s_FillCRgn(RgnHandle rgp,PixPatHandle pp)
{
#if !S_CARBON
PixPatHandle ps;

	if(QDGlobal(thePort)==s_redrawWindow)
	{
		ps = GetPenPixPat();
		s_PenPixPat(pp);
		PaintRgn(rgp);
		s_PenPixPat(ps);
	}
	else
#endif /*!S_CARBON*/
	{
		FillCRgn(rgp,pp);
	}
}

void	s_FillCRoundRect(Rect* rp,short s1,short s2,PixPatHandle pp)
{
#if !S_CARBON
PixPatHandle ps;

	if(QDGlobal(thePort)==s_redrawWindow)
	{
		ps = GetPenPixPat();
		s_PenPixPat(pp);
		PaintRoundRect(rp, s1, s2);
		s_PenPixPat(ps);
	}
	else
#endif /*!S_CARBON*/
	{
		FillCRoundRect(rp,s1,s2,pp);
	}
}


/* fix the bug that draws line in definition of "Regions" */

PicHandle s_OpenPicture(Rect *picRect)
{
#if !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		HidePen();
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*!S_CARBON*/
	return OpenPicture(picRect);
}	

void s_ClosePicture(void)
{
#if !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		ShowPen();
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*!S_CARBON*/
	ClosePicture();
}

#endif /*!S_UNIX*/ /******************** UNIX ********************/
PolyHandle s_OpenPoly(void)
{
#if !S_UNIX && !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		HidePen();
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*!S_UNIX && !S_CARBON*/
	return OpenPoly();
}	

void s_ClosePoly(void)
{
#if !S_UNIX && !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		ShowPen();
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*!S_UNIX && !S_CARBON*/
	ClosePoly();
}

#if !S_UNIX /******************** !!!! UNIX ********************/
void s_OpenRgn(void)
{
#if !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		HidePen();
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*!S_CARBON*/
	OpenRgn();
}	

void s_CloseRgn(RgnHandle rh)
{
#if !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		ShowPen();
		s_SetGWorld(s_redrawWindow,s_display);
	}
#endif /*!S_CARBON*/
	CloseRgn(rh);
}

/* Other Redraw Functions */

void s_DrawPicture(PicHandle pict, Rect *rp)
{
#if !S_CARBON
	if(QDGlobal(thePort)==s_redrawWindow)
	{
		s_SetGWorld(s_drawingWindow,nil);
		DrawPicture(pict, rp);
		s_SetGWorld(s_redrawWindow,s_display);
		s_RedrawWindow();
	}
	else
#endif /*!S_CARBON*/
		DrawPicture(pict, rp);
}


#ifndef SCLLocal
#include <s_define.c>
#else
#include "s_define.c"
#endif

#endif /*!S_UNIX*/
#endif /*pragma once*/
