/*
 *  s_String.c
 *  Version 1.9.1 / 010225
 *  by Satoshi Takahashi
 */

#ifndef S_STRING_C /*pragma once*/
#define S_STRING_C
#ifndef SCLLocal
#include <s_Config.h>
#else
#include "s_Config.h"
#endif


#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>

#ifndef SCLLocal
#include <s_String.h>

#include <s_undef.c>
#else
#include "s_String.h"

#include "s_undef.c"
#endif

#if !S_UNIX
/******************** c pascal conversion *********************/

void C2PString(const char* cstring, Str255 pstring)
{
	pstring[0] = strlen(cstring);
	strncpy((char *)pstring+1, cstring, pstring[0]);
}

void P2CString(Str255 pstring, char* cstring)
{
	strncpy(cstring, (char*)pstring+1, pstring[0]);
	cstring[pstring[0]] = 0;
}

#endif /*!S_UNIX*/

/******************** string as stream ********************/

void SkipSpaces(char **stringp)
{
	while (isspace(**stringp))
		(*stringp)++;
}

int SScanString(char **inputStringP,char *outputString)
{
	return SScanStringTabSepareted(inputStringP, outputString, 0);
}


int SScanStringTabSepareted(char **inputStringP,char *outputString, int tabF)
{
    if (!tabF)
        SkipSpaces(inputStringP);

	if (! **inputStringP)
		return 0;

	while ((!isspace(**inputStringP)) && **inputStringP)
	{
		*outputString = **inputStringP;
		outputString++;
		(*inputStringP)++;
	}
	*outputString = '\0';
	
    if (tabF)
    {
        while(inputStringP[0][0]
                && inputStringP[0][0] != '\t'
                && inputStringP[0][0] != '\n')
            inputStringP[0]++;
        inputStringP[0]++;
    }
    else
        SkipSpaces(inputStringP);
	
	return 1;
}

int SScanInt(char **inputStringP,int *outputInt)
{
int ret;
char numString[256];

	if (ret = SScanString(inputStringP, numString))
	{
		ret = sscanf(numString, "%d", outputInt);
	}
	return ret;
}


int SScanDouble(char **inputStringP,double *outputDouble)
{
	return SScanDoubleTabSeparated(inputStringP,outputDouble, 0);
}


int SScanDoubleTabSeparated(char **inputStringP,double *outputDouble, int tabF)
{
int ret;
char numString[256];

	if (ret = SScanStringTabSepareted(inputStringP, numString, tabF))
	{
		ret = sscanf(numString, "%lf", outputDouble);
	}
	return ret;
}




/******************** other ********************/

int HeadStrCL(char *keyword, char *target)
{
int length;
int i;

	length = strlen(keyword);
	for (i = 0; i < length; i++)
	{
		if (tolower(keyword[i]) != tolower(target[i]))
			return 0;
	}
	return 1;
}


#endif /*pragma once*/


